/////////////////////////////////////////////////////////////////////////////// 
// Copyright (C) 2003-2011, Open Design Alliance (the "Alliance"). 
// All rights reserved. 
// 
// This software and its documentation and related materials are owned by 
// the Alliance. The software may only be incorporated into application 
// programs owned by members of the Alliance, subject to a signed 
// Membership Agreement and Supplemental Software License Agreement with the
// Alliance. The structure and organization of this software are the valuable  
// trade secrets of the Alliance and its suppliers. The software is also 
// protected by copyright law and international treaty provisions. Application  
// programs incorporating this software must include the following statement 
// with their copyright notices:
//   
//   This application incorporates Teigha(R) software pursuant to a license 
//   agreement with Open Design Alliance.
//   Teigha(R) for .dwg files Copyright (C) 2003-2011 by Open Design Alliance. 
//   All rights reserved.
//
// By use of this software, its documentation or related materials, you 
// acknowledge and accept the above terms.
//
//
// *DWG is the native and proprietary file format for AutoCAD(R) and a trademark  
// of Autodesk, Inc.  Open Design Alliance is not associated with Autodesk.
///////////////////////////////////////////////////////////////////////////////


#ifndef __OD_GI_VIEWPORT_TRAITS__
#define __OD_GI_VIEWPORT_TRAITS__

#include "../TD_PackPush.h"

#include "../Gi/Gi.h"

/** Description:
    Library: TD_Gi
    {group:OdGi_Classes}
*/
class FIRSTDLL_EXPORT OdGiViewportTraits : public OdGiSubEntityTraits
{
public:
  ODRX_DECLARE_MEMBERS(OdGiViewportTraits);

  enum DefaultLightingType 
  {
    kOneDistantLight  = 0,
    kTwoDistantLights = 1,
    kBackLighting     = 2
  };

  virtual bool isDefaultLightingOn() const = 0;
  virtual void setDefaultLightingOn(bool b) = 0;

  virtual DefaultLightingType defaultLightingType() const = 0;
  virtual void setDefaultLightingType(DefaultLightingType) = 0;

  virtual void setAmbientLightColor(const OdCmEntityColor& color) = 0;
  virtual OdCmEntityColor ambientLightColor() const = 0;

  virtual void setContrast (double contrast) = 0;
  virtual double contrast() const = 0;

  virtual void setBrightness (double brightness) = 0;
  virtual double brightness() const = 0;

  virtual void setBackground(OdDbStub* bg) = 0;
  virtual OdDbStub* background() const = 0;

  virtual void setRenderEnvironment(OdDbStub* re) = 0;
  virtual OdDbStub* renderEnvironment () const = 0;

  virtual void setRenderSettings(OdDbStub* rs) = 0;
  virtual OdDbStub* renderSettings() const = 0;
};

typedef OdSmartPtr<OdGiViewportTraits> OdGiViewportTraitsPtr;

#include "../TD_PackPop.h"

#endif // __OD_GI_VIEWPORT_TRAITS__
