/////////////////////////////////////////////////////////////////////////////// 
// Copyright (C) 2003-2011, Open Design Alliance (the "Alliance"). 
// All rights reserved. 
// 
// This software and its documentation and related materials are owned by 
// the Alliance. The software may only be incorporated into application 
// programs owned by members of the Alliance, subject to a signed 
// Membership Agreement and Supplemental Software License Agreement with the
// Alliance. The structure and organization of this software are the valuable  
// trade secrets of the Alliance and its suppliers. The software is also 
// protected by copyright law and international treaty provisions. Application  
// programs incorporating this software must include the following statement 
// with their copyright notices:
//   
//   This application incorporates Teigha(R) software pursuant to a license 
//   agreement with Open Design Alliance.
//   Teigha(R) for .dwg files Copyright (C) 2003-2011 by Open Design Alliance. 
//   All rights reserved.
//
// By use of this software, its documentation or related materials, you 
// acknowledge and accept the above terms.
//
//
// *DWG is the native and proprietary file format for AutoCAD(R) and a trademark  
// of Autodesk, Inc.  Open Design Alliance is not associated with Autodesk.
///////////////////////////////////////////////////////////////////////////////



#ifndef QVAR_DEF_RO
#define DOUNDEF_QVAR_DEF_RO
#define QVAR_DEF_RO  QVAR_DEF /* {Secret} */
#endif

#ifndef QVAR_DEF_RO
#define DOUNDEF_QVAR_DEF_RO
#define QVAR_DEF_RO  QVAR_DEF /* {Secret} */
#endif


#ifndef ODTDIST
#define ODTDIST  double /* {Secret} */
#define DOUNDEF_ODTDIST
#endif

#ifndef ODTORIENT
#define ODTORIENT  double /* {Secret} */
#define DOUNDEF_ODTORIENT
#endif

#ifndef ODTANGLE
#define ODTANGLE double /* {Secret} */
#define DOUNDEF_ODTANGLE
#endif

#ifndef ODTLAYOUTID
#define ODTLAYOUTID  OdDbObjectId /* {Secret} */
#define DOUNDEF_ODTLAYOUTID
#endif

#ifndef ODTTEXTSTYLEID
#define ODTTEXTSTYLEID  OdDbObjectId /* {Secret} */
#define DOUNDEF_ODTTEXTSTYLEID
#endif

#ifndef ODTBOOL
#define ODTBOOL  bool /* {Secret} */
#define DOUNDEF_ODTBOOL
#endif

/*
#ifdef DATE
#define SAVED_DATE_DEFINITION
#undef DATE
#endif
*/

//         Type                   Name

QVAR_DEF_RO(ODTDIST,              BACKZ,            ValidateNone()    )
QVAR_DEF   (ODTLAYOUTID,          CTAB,             ValidateLayout()  )
QVAR_DEF   (OdString,             CPLOTSTYLE,       ValidateNone()    )
QVAR_DEF   (OdInt16,              CVPORT,           ValidateRange(0, 32767)    )
QVAR_DEF_RO(OdString,             DWGNAME,          ValidateNone()    )
QVAR_DEF_RO(OdString,             DWGPREFIX,        ValidateNone()    )
QVAR_DEF_RO(ODTBOOL,              DWGTITLED,        ValidateNone()    )
QVAR_DEF   (ODTDIST,              ELEVATION,        ValidateNone()    )
QVAR_DEF_RO(OdGePoint3d,          EXTMAX,           ValidateNone()    )
QVAR_DEF_RO(OdGePoint3d,          EXTMIN,           ValidateNone()    )
QVAR_DEF_RO(ODTDIST,              FRONTZ,           ValidateNone()    )
QVAR_DEF   (ODTBOOL,              GRIDMODE,         ValidateBOOL()    )
QVAR_DEF   (OdGePoint2d,          GRIDUNIT,         ValidateNone()    )
QVAR_DEF   (OdGePoint3d,          INSBASE,          ValidateNone()    )
QVAR_DEF_RO(ODTDIST,              LENSLENGTH,       ValidateNone()    )
QVAR_DEF   (ODTBOOL,              LIMCHECK,         ValidateBOOL()    )
QVAR_DEF   (OdGePoint2d,          LIMMAX,           ValidateNone()    )
QVAR_DEF   (OdGePoint2d,          LIMMIN,           ValidateNone()    )
QVAR_DEF   (ODTANGLE,             SNAPANG,          ValidateNone()    )
QVAR_DEF   (OdGePoint2d,          SNAPBASE,         ValidateNone()    )
QVAR_DEF   (OdInt16,              SNAPISOPAIR,      ValidateRange(0, 2)    )
QVAR_DEF   (ODTBOOL,              SNAPMODE,         ValidateBOOL()    )
QVAR_DEF   (ODTBOOL,              SNAPSTYL,         ValidateBOOL()    )
QVAR_DEF   (OdGePoint2d,          SNAPUNIT,         ValidateNone()    )
QVAR_DEF_RO(OdCodePageId,         SYSCODEPAGE,      ValidateNone()    )
QVAR_DEF_RO(OdGePoint3d,          TARGET,           ValidateNone()    )
QVAR_DEF   (ODTBOOL,              UCSFOLLOW,        ValidateBOOL()    )
QVAR_DEF   (OdInt16,              UCSICON,          ValidateNone()    )
QVAR_DEF   (ODTBOOL,              UCSVP,            ValidateBOOL()    )
QVAR_DEF_RO(ODTUCSNAME,           UCSNAME,          ValidateNone()    )
QVAR_DEF_RO(OdGePoint3d,          UCSORG,           ValidateNone()    )
QVAR_DEF_RO(OdGeVector3d,         UCSXDIR,          ValidateNone()    )
QVAR_DEF_RO(OdGeVector3d,         UCSYDIR,          ValidateNone()    )
QVAR_DEF_RO(OdGePoint3d,          VIEWCTR,          ValidateNone()    )
QVAR_DEF_RO(OdGeVector3d,         VIEWDIR,          ValidateNone()    )
QVAR_DEF_RO(OdInt16,              VIEWMODE,         ValidateNone()    )
QVAR_DEF_RO(ODTDIST,              VIEWSIZE,         ValidateNone()    )
QVAR_DEF_RO(ODTORIENT,            VIEWTWIST,        ValidateNone()    )
QVAR_DEF_RO(OdInt16,              WORLDUCS,         ValidateNone()    )
QVAR_DEF_RO(OdString,             LOGINNAME,        ValidateNone()    )
QVAR_DEF_RO(OdDbDate,             DATE,             ValidateNone()    )
QVAR_DEF_RO(double,               CANNOSCALEVALUE,  ValidateNone()    )
QVAR_DEF_RO(OdInt16,               DIMANNO,  ValidateNone()    )
QVAR_DEF(OdInt16,               ANNOALLVISIBLE,  ValidateRange(0,1)    )
/* TODO:
 CANNOSCALEVALUE
*/
QVAR_DEF   (OdInt16,              GRIDMAJOR,      ValidateRange(1,100) )
QVAR_DEF   (OdInt16,              GRIDDISPLAY,      ValidateRange(0,15) )

QVAR_DEF   (ODTBOOL,              PERSPECTIVE,      ValidateNone()    )
QVAR_DEF   (OdInt16,              DIMUNIT,          ValidateNone()    )

//-----------------------------------------
// Variables added in AC 2010 
//-----------------------------------------

/*** VARDOCS:
  <properties>
    <remarks>
      "\n    IMAGEFRAME Controls whether image frames are displayed and plotted"
      "\n"
      "\n    @table"
      "\n    Value   Description"
      "\n    0       Invisible"
      "\n    1       Is displayed and plotted"
      "\n    2       Is displayed but not plotted"
    </remarks>
  </properties>
*/
QVAR_DEF   (OdInt16,              IMAGEFRAME,       ValidateNone()    )
QVAR_DEF   (OdInt16,              FRAME,            ValidateNone()    )
QVAR_DEF   (OdInt16,              PDFFRAME,         ValidateNone()    )
QVAR_DEF   (OdInt16,              XCLIPFRAME,       ValidateNone()    )
QVAR_DEF   (OdInt8,               DWFFRAME,         ValidateNone()    )
QVAR_DEF   (OdInt8,               DGNFRAME,         ValidateNone()    )
QVAR_DEF   (OdInt8,               OLEFRAME,         ValidateNone()    )

QVAR_DEF   (ODTTEXTSTYLEID,       TEXTSTYLE,        ValidateTextStyle())
QVAR_DEF   (double,               TEXTSIZE,         ValidateNone()    )
QVAR_DEF_RO(OdDbDate,             CDATE,            ValidateNone()    )
QVAR_DEF_RO(ODTBOOL,              FULLOPEN,         ValidateBOOL()    )
QVAR_DEF   (OdInt16,              ZOOMPERCENT,      ValidateRange(1,20000) )

#ifdef DOUNDEF_ODTDIST
#undef ODTDIST
#undef DOUNDEF_ODTDIST
#endif

#ifdef DOUNDEF_ODTORIENT
#undef ODTORIENT
#undef DOUNDEF_ODTORIENT
#endif

#ifdef DOUNDEF_ODTANGLE
#undef ODTANGLE
#undef DOUNDEF_ODTANGLE
#endif

#ifdef DOUNDEF_ODTLAYOUTID
#undef ODTLAYOUTID
#undef DOUNDEF_ODTLAYOUTID
#endif

#ifdef DOUNDEF_ODTTEXTSTYLEID
#undef ODTTEXTSTYLEID
#undef DOUNDEF_ODTTEXTSTYLEID
#endif

#ifdef DOUNDEF_QVAR_DEF_RO
#undef QVAR_DEF_RO
#undef DOUNDEF_QVAR_DEF_RO
#endif

#ifdef DOUNDEF_ODTBOOL
#undef ODTBOOL
#undef DOUNDEF_ODTBOOL
#endif
